.\"	$NetBSD: lfs_bmapv.2,v 1.9 2004/05/13 10:20:58 wiz Exp $
.\"
.\" Copyright (c) 2000 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Konrad Schroder.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd May 23, 2000
.Dt LFS_BMAPV 2
.Os
.Sh NAME
.Nm lfs_bmapv
.Nd retrieve disk addresses for arrays of blocks
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In sys/types.h
.In ufs/lfs/lfs.h
.Ft int
.Fn lfs_bmapv "fsid_t *fsidp" "BLOCK_INFO *blkiov" "int blkcnt"
.Sh DESCRIPTION
.Fn lfs_bmapv
fills in the bi_daddr field for every block listed in the block array
.Fa blkiov
with the disk address corresponding to the logical block
.Fa bi_lbn
of the file with inode
.Fa bi_inode .
If
.Fa bi_lbn
is LFS_UNUSED_LBN, the disk location of the inode block containing the
file's inode will be returned in
.Fa bi_daddr
instead.
.Pp
The
.Fa fsidp
argument contains the id of the file system to which the inodes and
blocks belong.
The
.Fa blkiov
argument is an array of BLOCK_INFO structures (see below).
The
.Fa blkcnt
argument determines the size of the
.Fa blkiov
array.
.Bd -literal
typedef struct block_info {
    ino_t       bi_inode;     /* inode # */
    ufs_daddr_t bi_lbn;       /* logical block w/in file */
    ufs_daddr_t bi_daddr;     /* disk address of block */
    time_t      bi_segcreate; /* origin segment create time */
    int         bi_version;   /* file version number */
    void       *bi_bp;        /* data buffer */
    int         bi_size;      /* size of the block (if fragment) */
} BLOCK_INFO;
.Ed
.Sh RETURN VALUES
.Fn lfs_bmapv
returns 0 on success, or \-1 on error.
.Sh ERRORS
An error return from
.Fn lfs_bmapv
indicates:
.Bl -tag -width Er
.It Bq Er EFAULT
.Fa fsidp
points outside the process's allocated address space.
.It Bq Er EINVAL
.Fa *fsidp
does not specify a valid file system.
.El
.Sh SEE ALSO
.Xr lfs_markv 2 ,
.Xr lfs_segclean 2 ,
.Xr lfs_segwait 2 ,
.Xr lfs_cleanerd 8
.Sh HISTORY
The
.Fn lfs_bmapv
function call appeared in
.Bx 4.4 .
